haskell-gi-0.26.17: Generate Haskell bindings for GObject Introspection capable libraries

Safe Haskell | None
Language | Haskell2010

Data.GI.CodeGen.API

Synopsis

- data API
  - = APIConst Constant
  - | APIFunction Function
  - | APICallback Callback
  - | APIEnum Enumeration
  - | APIFlags Flags
  - | APIInterface Interface
  - | APIObject Object
  - | APIStruct Struct
  - | APIUnion Union
- data GIRInfo = GIRInfo {
  - girPCPackages :: [Text]
  - girNSName :: Text
  - girNSVersion :: Text
  - girAPIs :: [(Name, API)]
  - girCTypes :: Map Text Name
  }
- loadGIRInfo :: Bool -> Text -> Maybe Text -> [FilePath] -> [GIRRule] -> IO (GIRInfo, [GIRInfo])
- loadRawGIRInfo :: Bool -> Text -> Maybe Text -> [FilePath] -> IO GIRInfo
- data GIRRule
  - = GIRSetAttr (GIRPath, Name) Text
  - | GIRDeleteAttr GIRPath Name
  - | GIRAddNode GIRPath Name
  - | GIRDeleteNode GIRPath
- type GIRPath = [GIRNodeSpec]
- data GIRNodeSpec
  - = GIRNamed GIRNameTag
  - | GIRType Text
  - | GIRTypedName Text GIRNameTag
- data GIRNameTag
  - = GIRPlainName Text
  - | GIRRegex Text
- data Name = Name {
  - namespace :: Text
  - name :: Text
  }
- data Transfer
  - = TransferNothing
  - | TransferContainer
  - | TransferEverything
- data AllocationInfo = AllocationInfo {
  - allocCalloc :: AllocationOp
  - allocCopy :: AllocationOp
  - allocFree :: AllocationOp
  }
- data AllocationOp
  - = AllocationOpUnknown
  - | AllocationOp Text
- unknownAllocationInfo :: AllocationInfo
- data Direction
  - = DirectionIn
  - | DirectionOut
  - | DirectionInout
- data Scope
  - = ScopeTypeInvalid
  - | ScopeTypeCall
  - | ScopeTypeAsync
  - | ScopeTypeNotified
  - | ScopeTypeForever
- data DeprecationInfo
- data EnumerationMember = EnumerationMember {
  - enumMemberName :: Text
  - enumMemberValue :: Int64
  - enumMemberCId :: Text
  - enumMemberDoc :: Documentation
  }
- data PropertyFlag
  - = PropertyReadable
  - | PropertyWritable
  - | PropertyConstruct
  - | PropertyConstructOnly
- data MethodType
  - = Constructor
  - | MemberFunction
  - | OrdinaryMethod
- data Constant = Constant {
  - constantType :: Type
  - constantValue :: Text
  - constantCType :: Text
  - constantDocumentation :: Documentation
  - constantDeprecated :: Maybe DeprecationInfo
  }
- data Arg = Arg {
  - argCName :: Text
  - argType :: Type
  - argCType :: Maybe Text
  - direction :: Direction
  - mayBeNull :: Bool
  - argDoc :: Documentation
  - argScope :: Scope
  - argClosure :: Int
  - argDestroy :: Int
  - argCallerAllocates :: Bool
  - argCallbackUserData :: Bool
  - transfer :: Transfer
  }
- data Callable = Callable {
  - returnType :: Maybe Type
  - returnMayBeNull :: Bool
  - returnTransfer :: Transfer
  - returnDocumentation :: Documentation
  - args :: [Arg]
  - skipReturn :: Bool
  - callableThrows :: Bool
  - callableDeprecated :: Maybe DeprecationInfo
  - callableDocumentation :: Documentation
  - callableResolvable :: Maybe Bool
  }
- data Function = Function {
  - fnSymbol :: Text
  - fnMovedTo :: Maybe Text
  - fnCallable :: Callable
  }
- data Signal = Signal {
  - sigName :: Text
  - sigCallable :: Callable
  - sigDeprecated :: Maybe DeprecationInfo
  - sigDetailed :: Bool
  - sigDoc :: Documentation
  }
- data Property = Property {
  - propName :: Text
  - propType :: Type
  - propFlags :: [PropertyFlag]
  - propReadNullable :: Maybe Bool
  - propWriteNullable :: Maybe Bool
  - propSetter :: Maybe Text
  - propGetter :: Maybe Text
  - propTransfer :: Transfer
  - propDoc :: Documentation
  - propDeprecated :: Maybe DeprecationInfo
  }
- data Field = Field {
  - fieldName :: Text
  - fieldVisible :: Bool
  - fieldType :: Type
  - fieldIsPointer :: Maybe Bool
  - fieldCallback :: Maybe Callback
  - fieldOffset :: Int
  - fieldFlags :: [FieldInfoFlag]
  - fieldDocumentation :: Documentation
  - fieldDeprecated :: Maybe DeprecationInfo
  }
- data Struct = Struct {
  - structIsBoxed :: Bool
  - structAllocationInfo :: AllocationInfo
  - structTypeInit :: Maybe Text
  - structCType :: Maybe Text
  - structSize :: Int
  - gtypeStructFor :: Maybe Name
  - structIsDisguised :: Bool
  - structForceVisible :: Bool
  - structFields :: [Field]
  - structMethods :: [Method]
  - structDeprecated :: Maybe DeprecationInfo
  - structDocumentation :: Documentation
  }
- data Callback = Callback {
  - cbCallable :: Callable
  - cbCType :: Maybe Text
  - cbDocumentation :: Documentation
  }
- data Interface = Interface {
  - ifTypeInit :: Maybe Text
  - ifCType :: Maybe Text
  - ifDocumentation :: Documentation
  - ifPrerequisites :: [Name]
  - ifProperties :: [Property]
  - ifSignals :: [Signal]
  - ifMethods :: [Method]
  - ifAllocationInfo :: AllocationInfo
  - ifDeprecated :: Maybe DeprecationInfo
  }
- data Method = Method {
  - methodName :: Name
  - methodSymbol :: Text
  - methodType :: MethodType
  - methodMovedTo :: Maybe Text
  - methodCallable :: Callable
  }
- data Object = Object {
  - objParent :: Maybe Name
  - objTypeInit :: Text
  - objTypeName :: Text
  - objCType :: Maybe Text
  - objRefFunc :: Maybe Text
  - objUnrefFunc :: Maybe Text
  - objSetValueFunc :: Maybe Text
  - objGetValueFunc :: Maybe Text
  - objInterfaces :: [Name]
  - objDeprecated :: Maybe DeprecationInfo
  - objDocumentation :: Documentation
  - objMethods :: [Method]
  - objProperties :: [Property]
  - objSignals :: [Signal]
  }
- data Enumeration = Enumeration {
  - enumMembers :: [EnumerationMember]
  - enumErrorDomain :: Maybe Text
  - enumTypeInit :: Maybe Text
  - enumDocumentation :: Documentation
  - enumCType :: Text
  - enumStorageBytes :: Int
  - enumDeprecated :: Maybe DeprecationInfo
  }
- data Flags = Flags Enumeration
- data Union = Union {
  - unionIsBoxed :: Bool
  - unionAllocationInfo :: AllocationInfo
  - unionDocumentation :: Documentation
  - unionSize :: Int
  - unionTypeInit :: Maybe Text
  - unionFields :: [Field]
  - unionMethods :: [Method]
  - unionCType :: Maybe Text
  - unionDeprecated :: Maybe DeprecationInfo
  }

# Documentation

data API Source #

An element in the exposed API

Constructors

APIConst Constant |
APIFunction Function |
APICallback Callback |
APIEnum Enumeration |
APIFlags Flags |
APIInterface Interface |
APIObject Object |
APIStruct Struct |
APIUnion Union |

#### Instances

Instances details

Show API Source # |
Instance details Defined in Data.GI.CodeGen.API Methods showsPrec :: Int -> API -> ShowS Source # show :: API -> String Source # showList :: [API] -> ShowS Source #

data GIRInfo Source #

Constructors

GIRInfo |

Fields

- girPCPackages :: [Text]
- girNSName :: Text
- girNSVersion :: Text
- girAPIs :: [(Name, API)]
- girCTypes :: Map Text Name

#### Instances

Instances details

Show GIRInfo Source # |
Instance details Defined in Data.GI.CodeGen.API Methods showsPrec :: Int -> GIRInfo -> ShowS Source # show :: GIRInfo -> String Source # showList :: [GIRInfo] -> ShowS Source #

loadGIRInfo Source #

Arguments

:: Bool | verbose
-> Text | name
-> Maybe Text | version
-> [FilePath] | extra paths to search
-> [GIRRule] | fixups
-> IO (GIRInfo, [GIRInfo]) | (parsed doc, parsed deps)

Load and parse a GIR file, including its dependencies.

loadRawGIRInfo Source #

Arguments

:: Bool | verbose
-> Text | name
-> Maybe Text | version
-> [FilePath] | extra paths to search
-> IO GIRInfo | bare parsed document

Bare minimum loading and parsing of a single repository, without loading or parsing its dependencies, resolving aliases, or fixing up structs or interfaces.

data GIRRule Source #

A rule for modifying the GIR file.

Constructors

GIRSetAttr (GIRPath, Name) Text | (Path to element, attrName), newValue.
GIRDeleteAttr GIRPath Name | Delete the given attribute
GIRAddNode GIRPath Name | Add a child node at the given selector.
GIRDeleteNode GIRPath | Delete any nodes matching the given selector.

#### Instances

Instances details

Show GIRRule Source # |
Instance details Defined in Data.GI.CodeGen.API Methods showsPrec :: Int -> GIRRule -> ShowS Source # show :: GIRRule -> String Source # showList :: [GIRRule] -> ShowS Source #

type GIRPath = [GIRNodeSpec] Source #

Path to a node in the GIR file, starting from the document root of the GIR file. This is a very simplified version of something like XPath.

data GIRNodeSpec Source #

Node selector for a path in the GIR file.

Constructors

GIRNamed GIRNameTag | Node with the given "name" attr.
GIRType Text | Node of the given type.
GIRTypedName Text GIRNameTag | Combination of the above.

#### Instances

Instances details

Show GIRNodeSpec Source # |
Instance details Defined in Data.GI.CodeGen.API Methods showsPrec :: Int -> GIRNodeSpec -> ShowS Source # show :: GIRNodeSpec -> String Source # showList :: [GIRNodeSpec] -> ShowS Source #

data GIRNameTag Source #

A name tag, which is either a name or a regular expression.

Constructors

GIRPlainName Text |
GIRRegex Text |

#### Instances

Instances details

Show GIRNameTag Source # |
Instance details Defined in Data.GI.CodeGen.API Methods showsPrec :: Int -> GIRNameTag -> ShowS Source # show :: GIRNameTag -> String Source # showList :: [GIRNameTag] -> ShowS Source #

data Name Source #

Name for a symbol in the GIR file.

Constructors

Name |

Fields

- namespace :: Text
- name :: Text

#### Instances

Instances details

Show Name Source # |
Instance details Defined in Data.GI.GIR.BasicTypes Methods showsPrec :: Int -> Name -> ShowS Source # show :: Name -> String Source # showList :: [Name] -> ShowS Source #
Eq Name Source # |
Instance details Defined in Data.GI.GIR.BasicTypes Methods (==) :: Name -> Name -> Bool Source # (/=) :: Name -> Name -> Bool Source #
Ord Name Source # |
Instance details Defined in Data.GI.GIR.BasicTypes Methods compare :: Name -> Name -> Ordering Source # (<) :: Name -> Name -> Bool Source # (<=) :: Name -> Name -> Bool Source # (>) :: Name -> Name -> Bool Source # (>=) :: Name -> Name -> Bool Source # max :: Name -> Name -> Name Source # min :: Name -> Name -> Name Source #

data Transfer Source #

Transfer mode for an argument or property.

Constructors

TransferNothing |
TransferContainer |
TransferEverything |

#### Instances

Instances details

Show Transfer Source # |
Instance details Defined in Data.GI.GIR.BasicTypes Methods showsPrec :: Int -> Transfer -> ShowS Source # show :: Transfer -> String Source # showList :: [Transfer] -> ShowS Source #
Eq Transfer Source # |
Instance details Defined in Data.GI.GIR.BasicTypes Methods (==) :: Transfer -> Transfer -> Bool Source # (/=) :: Transfer -> Transfer -> Bool Source #
Ord Transfer Source # |
Instance details Defined in Data.GI.GIR.BasicTypes Methods compare :: Transfer -> Transfer -> Ordering Source # (<) :: Transfer -> Transfer -> Bool Source # (<=) :: Transfer -> Transfer -> Bool Source # (>) :: Transfer -> Transfer -> Bool Source # (>=) :: Transfer -> Transfer -> Bool Source # max :: Transfer -> Transfer -> Transfer Source # min :: Transfer -> Transfer -> Transfer Source #

data AllocationInfo Source #

Allocation/deallocation information for a given foreign pointer.

Constructors

AllocationInfo |

Fields

- allocCalloc :: AllocationOp
- allocCopy :: AllocationOp
- allocFree :: AllocationOp

#### Instances

Instances details

Show AllocationInfo Source # |
Instance details Defined in Data.GI.GIR.Allocation Methods showsPrec :: Int -> AllocationInfo -> ShowS Source # show :: AllocationInfo -> String Source # showList :: [AllocationInfo] -> ShowS Source #

data AllocationOp Source #

Information about a given allocation operation. It is either disallowed, allowed via the given function, or it is unknown at the current stage how to perform the operation.

Constructors

AllocationOpUnknown |
AllocationOp Text |

#### Instances

Instances details

Show AllocationOp Source # |
Instance details Defined in Data.GI.GIR.Allocation Methods showsPrec :: Int -> AllocationOp -> ShowS Source # show :: AllocationOp -> String Source # showList :: [AllocationOp] -> ShowS Source #
Eq AllocationOp Source # |
Instance details Defined in Data.GI.GIR.Allocation Methods (==) :: AllocationOp -> AllocationOp -> Bool Source # (/=) :: AllocationOp -> AllocationOp -> Bool Source #

unknownAllocationInfo :: AllocationInfo Source #

A convenience function, filling in all the allocation info to unknown.

data Direction Source #

Constructors

DirectionIn |
DirectionOut |
DirectionInout |

#### Instances

Instances details

Show Direction Source # |
Instance details Defined in Data.GI.GIR.Arg Methods showsPrec :: Int -> Direction -> ShowS Source # show :: Direction -> String Source # showList :: [Direction] -> ShowS Source #
Eq Direction Source # |
Instance details Defined in Data.GI.GIR.Arg Methods (==) :: Direction -> Direction -> Bool Source # (/=) :: Direction -> Direction -> Bool Source #
Ord Direction Source # |
Instance details Defined in Data.GI.GIR.Arg Methods compare :: Direction -> Direction -> Ordering Source # (<) :: Direction -> Direction -> Bool Source # (<=) :: Direction -> Direction -> Bool Source # (>) :: Direction -> Direction -> Bool Source # (>=) :: Direction -> Direction -> Bool Source # max :: Direction -> Direction -> Direction Source # min :: Direction -> Direction -> Direction Source #

data Scope Source #

Constructors

ScopeTypeInvalid |
ScopeTypeCall |
ScopeTypeAsync |
ScopeTypeNotified |
ScopeTypeForever |

#### Instances

Instances details

Show Scope Source # |
Instance details Defined in Data.GI.GIR.Arg Methods showsPrec :: Int -> Scope -> ShowS Source # show :: Scope -> String Source # showList :: [Scope] -> ShowS Source #
Eq Scope Source # |
Instance details Defined in Data.GI.GIR.Arg Methods (==) :: Scope -> Scope -> Bool Source # (/=) :: Scope -> Scope -> Bool Source #
Ord Scope Source # |
Instance details Defined in Data.GI.GIR.Arg Methods compare :: Scope -> Scope -> Ordering Source # (<) :: Scope -> Scope -> Bool Source # (<=) :: Scope -> Scope -> Bool Source # (>) :: Scope -> Scope -> Bool Source # (>=) :: Scope -> Scope -> Bool Source # max :: Scope -> Scope -> Scope Source # min :: Scope -> Scope -> Scope Source #

data DeprecationInfo Source #

Deprecation information on a symbol.

#### Instances

Instances details

Show DeprecationInfo Source # |
Instance details Defined in Data.GI.GIR.Deprecation Methods showsPrec :: Int -> DeprecationInfo -> ShowS Source # show :: DeprecationInfo -> String Source # showList :: [DeprecationInfo] -> ShowS Source #
Eq DeprecationInfo Source # |
Instance details Defined in Data.GI.GIR.Deprecation Methods (==) :: DeprecationInfo -> DeprecationInfo -> Bool Source # (/=) :: DeprecationInfo -> DeprecationInfo -> Bool Source #

data EnumerationMember Source #

Member of an enumeration.

Constructors

EnumerationMember |

Fields

- enumMemberName :: Text
- enumMemberValue :: Int64
- enumMemberCId :: Text
- enumMemberDoc :: Documentation

#### Instances

Instances details

Show EnumerationMember Source # |
Instance details Defined in Data.GI.GIR.Enum Methods showsPrec :: Int -> EnumerationMember -> ShowS Source # show :: EnumerationMember -> String Source # showList :: [EnumerationMember] -> ShowS Source #

data PropertyFlag Source #

Constructors

PropertyReadable |
PropertyWritable |
PropertyConstruct |
PropertyConstructOnly |

#### Instances

Instances details

Show PropertyFlag Source # |
Instance details Defined in Data.GI.GIR.Property Methods showsPrec :: Int -> PropertyFlag -> ShowS Source # show :: PropertyFlag -> String Source # showList :: [PropertyFlag] -> ShowS Source #
Eq PropertyFlag Source # |
Instance details Defined in Data.GI.GIR.Property Methods (==) :: PropertyFlag -> PropertyFlag -> Bool Source # (/=) :: PropertyFlag -> PropertyFlag -> Bool Source #

data MethodType Source #

Constructors

Constructor | Constructs an instance of the parent type
MemberFunction | A function in the namespace
OrdinaryMethod | A function taking the parent instance as first argument.

#### Instances

Instances details

Show MethodType Source # |
Instance details Defined in Data.GI.GIR.Method Methods showsPrec :: Int -> MethodType -> ShowS Source # show :: MethodType -> String Source # showList :: [MethodType] -> ShowS Source #
Eq MethodType Source # |
Instance details Defined in Data.GI.GIR.Method Methods (==) :: MethodType -> MethodType -> Bool Source # (/=) :: MethodType -> MethodType -> Bool Source #

data Constant Source #

Info about a constant.

Constructors

Constant |

Fields

- constantType :: Type
- constantValue :: Text
- constantCType :: Text
- constantDocumentation :: Documentation
- constantDeprecated :: Maybe DeprecationInfo

#### Instances

Instances details

Show Constant Source # |
Instance details Defined in Data.GI.GIR.Constant Methods showsPrec :: Int -> Constant -> ShowS Source # show :: Constant -> String Source # showList :: [Constant] -> ShowS Source #

data Arg Source #

Constructors

Arg |

Fields

- argCName :: Text

  C name for the argument. For a escaped name valid in Haskell code, use `escapedArgName`.

- argType :: Type
- argCType :: Maybe Text
- direction :: Direction
- mayBeNull :: Bool
- argDoc :: Documentation
- argScope :: Scope
- argClosure :: Int
- argDestroy :: Int
- argCallerAllocates :: Bool
- argCallbackUserData :: Bool

  Whether the argument is an "user-data" argument for a callback.

- transfer :: Transfer

#### Instances

Instances details

Show Arg Source # |
Instance details Defined in Data.GI.GIR.Arg Methods showsPrec :: Int -> Arg -> ShowS Source # show :: Arg -> String Source # showList :: [Arg] -> ShowS Source #
Eq Arg Source # |
Instance details Defined in Data.GI.GIR.Arg Methods (==) :: Arg -> Arg -> Bool Source # (/=) :: Arg -> Arg -> Bool Source #
Ord Arg Source # |
Instance details Defined in Data.GI.GIR.Arg Methods compare :: Arg -> Arg -> Ordering Source # (<) :: Arg -> Arg -> Bool Source # (<=) :: Arg -> Arg -> Bool Source # (>) :: Arg -> Arg -> Bool Source # (>=) :: Arg -> Arg -> Bool Source # max :: Arg -> Arg -> Arg Source # min :: Arg -> Arg -> Arg Source #

data Callable Source #

Constructors

Callable |

Fields

- returnType :: Maybe Type
- returnMayBeNull :: Bool
- returnTransfer :: Transfer
- returnDocumentation :: Documentation
- args :: [Arg]
- skipReturn :: Bool
- callableThrows :: Bool
- callableDeprecated :: Maybe DeprecationInfo
- callableDocumentation :: Documentation
- callableResolvable :: Maybe Bool

  Whether the symbol for this callable can be resolved in the dynamical library associated with the current introspection data. `Nothing` means that we have not checked yet.

#### Instances

Instances details

Show Callable Source # |
Instance details Defined in Data.GI.GIR.Callable Methods showsPrec :: Int -> Callable -> ShowS Source # show :: Callable -> String Source # showList :: [Callable] -> ShowS Source #
Eq Callable Source # |
Instance details Defined in Data.GI.GIR.Callable Methods (==) :: Callable -> Callable -> Bool Source # (/=) :: Callable -> Callable -> Bool Source #

data Function Source #

Constructors

Function |

Fields

- fnSymbol :: Text

  The symbol in the dynlib that this function refers to.

- fnMovedTo :: Maybe Text
- fnCallable :: Callable

#### Instances

Instances details

Show Function Source # |
Instance details Defined in Data.GI.GIR.Function Methods showsPrec :: Int -> Function -> ShowS Source # show :: Function -> String Source # showList :: [Function] -> ShowS Source #

data Signal Source #

Constructors

Signal |

Fields

- sigName :: Text
- sigCallable :: Callable
- sigDeprecated :: Maybe DeprecationInfo
- sigDetailed :: Bool
- sigDoc :: Documentation

#### Instances

Instances details

Show Signal Source # |
Instance details Defined in Data.GI.GIR.Signal Methods showsPrec :: Int -> Signal -> ShowS Source # show :: Signal -> String Source # showList :: [Signal] -> ShowS Source #
Eq Signal Source # |
Instance details Defined in Data.GI.GIR.Signal Methods (==) :: Signal -> Signal -> Bool Source # (/=) :: Signal -> Signal -> Bool Source #

data Property Source #

Constructors

Property |

Fields

- propName :: Text
- propType :: Type
- propFlags :: [PropertyFlag]
- propReadNullable :: Maybe Bool
- propWriteNullable :: Maybe Bool
- propSetter :: Maybe Text
- propGetter :: Maybe Text
- propTransfer :: Transfer
- propDoc :: Documentation
- propDeprecated :: Maybe DeprecationInfo

#### Instances

Instances details

Show Property Source # |
Instance details Defined in Data.GI.GIR.Property Methods showsPrec :: Int -> Property -> ShowS Source # show :: Property -> String Source # showList :: [Property] -> ShowS Source #
Eq Property Source # |
Instance details Defined in Data.GI.GIR.Property Methods (==) :: Property -> Property -> Bool Source # (/=) :: Property -> Property -> Bool Source #

data Field Source #

Constructors

Field |

Fields

- fieldName :: Text
- fieldVisible :: Bool
- fieldType :: Type
- fieldIsPointer :: Maybe Bool

  `Nothing` if not known.

- fieldCallback :: Maybe Callback
- fieldOffset :: Int
- fieldFlags :: [FieldInfoFlag]
- fieldDocumentation :: Documentation
- fieldDeprecated :: Maybe DeprecationInfo

#### Instances

Instances details

Show Field Source # |
Instance details Defined in Data.GI.GIR.Field Methods showsPrec :: Int -> Field -> ShowS Source # show :: Field -> String Source # showList :: [Field] -> ShowS Source #

data Struct Source #

Constructors

Struct |

Fields

- structIsBoxed :: Bool
- structAllocationInfo :: AllocationInfo
- structTypeInit :: Maybe Text
- structCType :: Maybe Text
- structSize :: Int
- gtypeStructFor :: Maybe Name
- structIsDisguised :: Bool
- structForceVisible :: Bool
- structFields :: [Field]
- structMethods :: [Method]
- structDeprecated :: Maybe DeprecationInfo
- structDocumentation :: Documentation

#### Instances

Instances details

Show Struct Source # |
Instance details Defined in Data.GI.GIR.Struct Methods showsPrec :: Int -> Struct -> ShowS Source # show :: Struct -> String Source # showList :: [Struct] -> ShowS Source #

data Callback Source #

Constructors

Callback |

Fields

- cbCallable :: Callable
- cbCType :: Maybe Text
- cbDocumentation :: Documentation

#### Instances

Instances details

Show Callback Source # |
Instance details Defined in Data.GI.GIR.Callback Methods showsPrec :: Int -> Callback -> ShowS Source # show :: Callback -> String Source # showList :: [Callback] -> ShowS Source #

data Interface Source #

Constructors

Interface |

Fields

- ifTypeInit :: Maybe Text
- ifCType :: Maybe Text
- ifDocumentation :: Documentation
- ifPrerequisites :: [Name]
- ifProperties :: [Property]
- ifSignals :: [Signal]
- ifMethods :: [Method]
- ifAllocationInfo :: AllocationInfo
- ifDeprecated :: Maybe DeprecationInfo

#### Instances

Instances details

Show Interface Source # |
Instance details Defined in Data.GI.GIR.Interface Methods showsPrec :: Int -> Interface -> ShowS Source # show :: Interface -> String Source # showList :: [Interface] -> ShowS Source #

data Method Source #

Constructors

Method |

Fields

- methodName :: Name
- methodSymbol :: Text

  The symbol in the dynlib that this method refers to.

- methodType :: MethodType
- methodMovedTo :: Maybe Text
- methodCallable :: Callable

#### Instances

Instances details

Show Method Source # |
Instance details Defined in Data.GI.GIR.Method Methods showsPrec :: Int -> Method -> ShowS Source # show :: Method -> String Source # showList :: [Method] -> ShowS Source #
Eq Method Source # |
Instance details Defined in Data.GI.GIR.Method Methods (==) :: Method -> Method -> Bool Source # (/=) :: Method -> Method -> Bool Source #

data Object Source #

Constructors

Object |

Fields

- objParent :: Maybe Name
- objTypeInit :: Text
- objTypeName :: Text
- objCType :: Maybe Text
- objRefFunc :: Maybe Text
- objUnrefFunc :: Maybe Text
- objSetValueFunc :: Maybe Text
- objGetValueFunc :: Maybe Text
- objInterfaces :: [Name]
- objDeprecated :: Maybe DeprecationInfo
- objDocumentation :: Documentation
- objMethods :: [Method]
- objProperties :: [Property]
- objSignals :: [Signal]

#### Instances

Instances details

Show Object Source # |
Instance details Defined in Data.GI.GIR.Object Methods showsPrec :: Int -> Object -> ShowS Source # show :: Object -> String Source # showList :: [Object] -> ShowS Source #

data Enumeration Source #

Constructors

Enumeration |

Fields

- enumMembers :: [EnumerationMember]
- enumErrorDomain :: Maybe Text
- enumTypeInit :: Maybe Text
- enumDocumentation :: Documentation
- enumCType :: Text
- enumStorageBytes :: Int

  Bytes used for storage of this struct.

- enumDeprecated :: Maybe DeprecationInfo

#### Instances

Instances details

Show Enumeration Source # |
Instance details Defined in Data.GI.GIR.Enum Methods showsPrec :: Int -> Enumeration -> ShowS Source # show :: Enumeration -> String Source # showList :: [Enumeration] -> ShowS Source #

data Flags Source #

Constructors

Flags Enumeration |

#### Instances

Instances details

Show Flags Source # |
Instance details Defined in Data.GI.GIR.Flags Methods showsPrec :: Int -> Flags -> ShowS Source # show :: Flags -> String Source # showList :: [Flags] -> ShowS Source #

data Union Source #

Constructors

Union |

Fields

- unionIsBoxed :: Bool
- unionAllocationInfo :: AllocationInfo
- unionDocumentation :: Documentation
- unionSize :: Int
- unionTypeInit :: Maybe Text
- unionFields :: [Field]
- unionMethods :: [Method]
- unionCType :: Maybe Text
- unionDeprecated :: Maybe DeprecationInfo

#### Instances

Instances details

Show Union Source # |
Instance details Defined in Data.GI.GIR.Union Methods showsPrec :: Int -> Union -> ShowS Source # show :: Union -> String Source # showList :: [Union] -> ShowS Source #